  /* GRASPTC:   ᪨   ᯮ짮  ࡮ .
		Graphics System for Programming in Turbo C.
  */
  #include <dos.h>
  #include <stdio.h>
  #include <graphics.h>
  #include <conio.h>
  #include <math.h>
  #include <stdlib.h>
  #include <alloc.h>
  #include <string.h>
  #include "grasptc.h"

  /* 㭪樨 ⠭ ࠡ稪 뢠  ᪮ ०: */
  /* Functions to install the break handler for graphics mode:         */
  #define CTRL_C 0x2E03
  #define CTRL_BREAK 0x8000
  static void interrupt (*oldInt9)(void);
  static int *keybuffer  = (int *)0x41E;
  static int *buffertail = (int *)0x41C;
  static int handler_installed = 0;

  static void restore_old_break(void)
  { if (handler_installed)
    { setvect(9, oldInt9); handler_installed = 0;
    }
  }

  static void interrupt newInt9(void)
  { unsigned int tail, code;
    oldInt9();
    /* *buffertail = 30, 32, ..., 60 */
    tail = (*buffertail - 30) >> 1;
    /* tail = 0, 1, ..., 15 */
    code = keybuffer[tail ? tail - 1 : 15];
    if (code == CTRL_C || code == CTRL_BREAK)
    { to_text();
      exit(1);
    }
  }

  static void installBreak(void)
  { if (!handler_installed)
    { oldInt9 = getvect(9); setvect(9,newInt9);
      handler_installed = 1;
    }
  }

  #define plotcoor(x) ((int)(1000 * (x) + 0.5))

  int X__max, Y__max, foregrcolor, backgrcolor, colorsum;
  static int Xcur, Ycur;
  float x_max, y_max, horfact, vertfact;
  FILE *fplot=NULL;

  
  void boundaries_uc(void)
  { int w, h;
    getaspectratio(&w, &h);
    y_max = x_max * (float)Y__max*h/((float)X__max*w);
    horfact = X__max/x_max; vertfact = Y__max/y_max;
  }
  
  void initgr(void)
  { int gdriver=DETECT, gmode;
    /* ᫥騥 饭  㭪 registerfarbgidriver() 
       registerfarbgifont() ।,   㦥 뫨 ᮧ
       ꥪ 䠩 CGAF.OBJ, EGAVGAF.OBJ, HERCF.OBJ, TRIPF.OBJ,
       LITTF.OBJ  SANSF.OBJ     BGIOBJ /F CGA,
       EGIOBJ /F EGAVGA  ⠪ .   - 
          㣨  ᢮ ᬮ७ (. ࠣ 1.7).

       The following calls to registerfarbgidriver() and
       registerfarbgifont() assume that you have created the
       object files CGAF.OBJ, EGAVGAF.OBJ, HERCF.OBJ,
       TRIPF.OBJ, LITTF.OBJ, SANSF.OBJ, using the commands
       BGIOBJ /F CGA, BGIOBJ /F EGAVGA, and so on. You can omit
       some of these calls or insert others as you like, see
       also Section 1.7.
    */

    registerfarbgidriver(CGA_driver_far);
    registerfarbgidriver(EGAVGA_driver_far);
    registerfarbgidriver(Herc_driver_far);
    registerfarbgifont(triplex_font_far);
    registerfarbgifont(small_font_far);
    registerfarbgifont(sansserif_font_far);
    initgraph(&gdriver, &gmode, "\\tc");
    /*  ⨩ 㬥 "\\tc" 筮   㪠뢠 ! */
    /*  Third argument "\\tc" will normally not be used!      */
    if (graphresult())
    { printf /* "Graphics driver not available." */
	   ("\n᪨ ࠩ  㯥.\n"); exit(1);
    }
    installBreak();
    foregrcolor = getcolor(); backgrcolor = getbkcolor();
    colorsum = foregrcolor + backgrcolor;
    X__max = getmaxx(); Y__max = getmaxy();
    x_max=10.0;
    boundaries_uc();
    if (fplot != NULL)
      fprintf(fplot, "IN;SC0,10000,0,%d;\n", plotcoor(y_max));
  }

  void invertpixel(int X, int Y)
  { putpixel(X, Y, colorsum - getpixel(X, Y));
  }

  int IX(float x)
  { return (int) (x * horfact + 0.5);
  }
  
  int IY(float y)
  { return Y__max - (int)(y * vertfact + 0.5);
  }
  
  void move(float x, float y)
  { Xcur = IX(x); Ycur = IY(y);
    moveto(Xcur, Ycur);
    if (fplot != NULL) fprintf(fplot, "PU;PA%d,%d;",
    plotcoor(x), plotcoor(y));
  }
  
  void draw(float x, float y)
  { int X0=Xcur, Y0=Ycur;
    Xcur = IX(x); Ycur = IY(y);
    line(X0, Y0, Xcur, Ycur);
    moveto(Xcur, Ycur);
    if (fplot != NULL) fprintf(fplot, "PD;PA%d,%d;\n",
    plotcoor(x), plotcoor(y));
  }
  
  void to_text(void)
  { closegraph(); 
    restore_old_break();
  }
  
  void endgr(void)
  { getch(); to_text();
  }
  
  void grtext(float xleft, float ylower, float heightpercent, char *str)
  { char *s;
    int len, charsize;
    float widthpercent=heightpercent*4.0/7.0;
    len = strlen(str);
    s = farmalloc(len+2);
    if (s == NULL){to_text(); printf("farmalloc");exit(1);}
    strcpy(s, str);
    s[len] = '\003'; s[len+1] = '\0';
    if (fplot != NULL)
    { fprintf(fplot, "SR%3.1f,%3.1f;",
      widthpercent, heightpercent);
      fprintf(fplot, "PU;PA%d,%d;LB%s;\n",
      plotcoor(xleft), plotcoor(ylower), s);
    }
    charsize = (int)(heightpercent/2 + 0.5);
    if (charsize > 10) charsize = 10;
    settextstyle(SANS_SERIF_FONT, HORIZ_DIR, charsize);
    outtextxy(IX(xleft), IY(ylower)-textheight(str)-charsize, str);
    farfree(s);
  }

  void far * far _graphgetmem(unsigned size)
  { char far *p;
    p = farmalloc((long)size);
    if (p == NULL)       /* "Mem. space in _graphgetmem" */
    { printf (" 墠⨫   㭪樨 _graphgetmem"); exit(1);}
    return p;
  }
  
  void far _graphfreemem(void far *ptr, unsigned size)
  { farfree(ptr);
  }
  
  void line_uc(float x1, float y1, float x2, float y2)
  { line(IX(x1), IY(y1), IX(x2), IY(y2));
  }
  
  void circle_uc(float x, float y, float r)
  { circle(IX(x), IY(y), IX(r));
  }
  
  int XPIX(float xdim)
  { return (int)(xdim * horfact + 0.5);
  }
  int YPIX(float ydim)
  { return (int)(ydim * vertfact + 0.5);
  }

  static float xarc_C, yarc_C, xarc_start, yarc_start, xarc_end, yarc_end;
  
  void arc_uc(float xC, float yC, float stangle,
              float endangle, float radius, int nlinesegments)
  { float theta, phi;
    int i;
    while (endangle < stangle) endangle += 2*PI;
    theta = (endangle - stangle)/nlinesegments;
    xarc_start = xC + radius*cos(stangle);
    yarc_start = yC + radius*sin(stangle);
    xarc_end = xC + radius*cos(endangle);
    yarc_end = yC + radius*sin(endangle);
    move(xarc_start, yarc_start);
    for (i=1; i<nlinesegments; i++)
    { phi = stangle + i * theta;
      draw(xC+radius*cos(phi), yC+radius*sin(phi));
    }
    draw(xarc_end, yarc_end);
    xarc_C = xC; yarc_C = yC;
  }

  void getarc_uc(struct arc_uctype *arccoords)
  { arccoords->x = xarc_C;
    arccoords->y = yarc_C;
    arccoords->xstart = xarc_start;
    arccoords->ystart = yarc_start;
    arccoords->xend = xarc_end;
    arccoords->yend = yarc_end;
  }
  
  float angle(float x, float y)
  { return (x > 0 ? atan(y/x) :
            x < 0 ? PI + atan(y/x) :
            y >= 0 ? PI/2 : 3*PI/2);
  }

  float drawarc3(float xA, float yA,
               float xB, float yB,
               float xC, float yC,
               float *pr)
  { float u1, u2, n1, n2, xD, yD, v1, v2, m1, m2, xE, yE, lambda,
      xO, yO, r1, r2, r, stangle, endangle, phiA, phiC, determinant;
    int nsteps;
    u1 = xB - xA; u2 = yB - yA; /*  u ࠢ  A  B    */
				/* Vector u points from A to B    */
    n1 = u2; n2 = -u1;          /*  n ௥७  u   */
				/* Vector n is perpendicular to u */
    xD = (xA+xB)/2; yD = (yA+yB)/2;  /* D = । 窠 AB      */
                                     /* D is midpoint of AB       */
    v1 = xC - xB; v2 = yC - yB; /*  v ࠢ  B  C    */
				/* Vector v points from B to C    */
    m1 = v2; m2 = -v1;          /*  m ௥७  v   */
				/* Vector m is perpendicular to v */
    xE = (xB+xC)/2; yE = (yB+yC)/2;  /* E = । 窠 BC      */
				     /* E is midpoint of BC       */
    determinant = m2*n1 - m1*n2;
    if (determinant == 0.0) return 0.0;
    lambda = (m2*(xE-xD) - m1*(yE-yD))/determinant;
		/*  lambda.n ࠢ  窨 D   O */
			    /* Vector lambda.n points from D to O */
	 /* O = 業 㦭, 室饩 १ 窨 A, B  C */
    xO = xD + lambda * n1;  /* O is center of circle through      */
    yO = yD + lambda * n2;  /* A, B, and C.                       */
    r1 = xA-xO; r2 = yA-yO; /*  (r1, r2) ࠢ  O  A */
			    /* Vector (r1, r2) points from O to A */
    r = sqrt(r1*r1 + r2*r2);
    phiA = angle(r1, r2);
    phiC = angle(xC-xO, yC-yO);
    if (determinant > 0)
    { stangle = phiA; endangle = phiC;
    } else
    { stangle = phiC; endangle = phiA;
    }
    if (endangle < stangle) endangle += 2*PI;
    nsteps = (int)(r * (endangle - stangle) * 10) + 1;
      /* ᫮ 蠣    ࠤ, ⠪   㣫  */
      /* Number of steps dependent on both radius and angle */
    arc_uc(xO, yO, stangle, endangle, r, nsteps);
    *pr = r;
    return determinant;
  }

  float fillet(float xA, float yA, float xB, float yB,
               float xC, float yC, float r)
  { float n1, n2, m1, m2, BA, BC, s1, s2, length_of_s,
      b1, b2, cosa, sina, BO1, BO2, xO, yO, proj,
      xD, yD, xE, yE, xF, yF, q;
    n1 = xA - xB; n2 = yA - yB;
    BA = sqrt(n1*n1 + n2*n2);
    n1 /= BA; n2 /= BA;        
  
    m1 = xC - xB; m2 = yC - yB;
    BC = sqrt(m1*m1 + m2*m2);
    m1 /= BC; m2 /= BC;
  
    s1 = n1 + m1; s2 = n2 + m2;
    length_of_s = sqrt(s1*s1 + s2*s2);
    b1 = s1/length_of_s; b2 = s2/length_of_s;
    cosa = length_of_s/2;
    sina = sqrt(1 - cosa*cosa); q = r/sina;
    BO1 = q * b1; BO2 = q * b2;
    xO = xB + BO1; yO = yB + BO2;
    proj = BO1 * n1 + BO2 * n2;
    xD = xB + proj * n1; yD = yB + proj * n2;
    xE = xB + proj * m1; yE = yB + proj * m2;
    xF = xO - r * b1; yF = yO - r * b2;
    return drawarc3(xD, yD, xF, yF, xE, yE, &r);
  }

  void fillcircle_uc(float x, float y, float radius)
  { fillellipse(IX(x), IY(y), XPIX(radius), YPIX(radius));
  }

  #define COSDELTA 0.996917333733
  #define SINDELTA 0.078459095728

  void circle80_pc(int XC, int YC, int R)
  /* 㦭 பᨬ ࠢ 80-㣮쭨  ⥬
     ᥫ न
     Circle, approximated by regular 80-gon, based on pixel coordinates
  */
  { static int first=1, stdpoints[162];
    int j=0, H, V, points[162];
    double costh, sinth, c0, s0;
    float x, y;
    if (first)
    { first = 0;
      costh = 1.0; sinth = 0.0;
      for (j=0; j<=40; j+=2)
      { H = (int)(1e4 * costh + 0.5);
        V = (int)(1e4 * sinth * vertfact/horfact + 0.5);
        stdpoints[j] = H; stdpoints[j+1] = V;
        if (j)
        { stdpoints[160-j] = H;
          stdpoints[161-j] = -V;
        }
        if (j != 40)
        { stdpoints[80-j] = -H; stdpoints[81-j] = V;
          if (j)
          { stdpoints[80+j] = -H;
            stdpoints[81+j] = -V;
          }
        }
        c0 = costh; s0 = sinth;
        costh = c0 * COSDELTA - s0 * SINDELTA;
        sinth = s0 * COSDELTA + c0 * SINDELTA;
      }
      stdpoints[160] = stdpoints[0];
      stdpoints[161] = stdpoints[1];
    }
    for (j=0; j<=160; j+=2)
    { points[j] = XC + (int)(stdpoints[j]*(long)R/10000L);
      points[j+1] = YC + (int)(stdpoints[j+1]*(long)R/10000L);
      if (j) invertpixel(points[j], points[j+1]);
      /* Necessary in case of XOR_PUT */
    }
    if (fplot == NULL) drawpoly(81, points); else
    { for (j=0; j<=80; j++)
      { x = points[2*j]/horfact; 
        y = (Y__max - points[2*j+1])/vertfact;
        if (j==0) move(x, y); else draw(x, y); 
      }
    }
  }

  void circle80_uc(float xC, float yC, float r)

  /* 㦭 பᨬ ࠢ 80-㣮쭨  ⥬
     짮⥫᪨ न
     Circle, approximated by regular 80-gon, based on user coordinates
  */
  { circle80_pc(IX(xC), IY(yC), XPIX(r));
  }

  static float xA, yA, xB, yB, xC, yC;

  void fatline0(float x1, float y1, float x2, float y2, float d)
  { float dx, dy, dxhw, dyhw, factor, r=d/2;
    int points[10];
    dx = x2 - x1; dy = y2 - y1;
    factor = r/sqrt(dx * dx + dy * dy);
    dxhw = dy * factor;  /* Delta x for half the width */
    dyhw = dx * factor;  /* Delta y for half the width */
    points[0] = IX(x1+dxhw); points[1] = IY(y1-dyhw);
    points[2] = IX(x2+dxhw); points[3] = IY(y2-dyhw);
    points[4] = IX(x2-dxhw); points[5] = IY(y2+dyhw);
    points[6] = IX(x1-dxhw); points[7] = IY(y1+dyhw);
    points[8] = points[0]; points[9] = points[1];
    fillpoly(5, points);
    xA = xB; yA = yB;
    xB = x1; yB = y1;
    xC = x2; yC = y2;
  }

  void fatline(float x1, float y1, float x2, float y2, float d)
  { float r=d/2;
    fatline0(x1, y1, x2, y2, d);
    fillcircle_uc(x1, y1, r);
    fillcircle_uc(x2, y2, r);
  }
  void sharpjoint(float d)
  { float r=d/2, BA, BC, dxBA, dyBA, dxBC, dyBC, s,
          sina, factor, xD, yD, xE, yE, xF, yF, m1,
          m2, n1, n2, rm1, rm2, rn1, rn2;
    int points[10];
    dxBA = xA - xB; dyBA = yA - yB;
    dxBC = xC - xB; dyBC = yC - yB;
    BA = sqrt(dxBA * dxBA + dyBA * dyBA);
    BC = sqrt(dxBC * dxBC + dyBC * dyBC);
    n1 = -dxBA/BA; n2 = -dyBA/BA;
    m1 = -dxBC/BC; m2 = -dyBC/BC;
    s = m1 * n2 - n1 * m2;
    sina = fabs(s);
    factor = r/sina;
    xD = xB + factor * (m1 + n1);
    yD = yB + factor * (m2 + n2);
    rm1 = r * m1; rm2 = r * m2;
    rn1 = r * n1; rn2 = r * n2;
    if (s > 0)
    { xE = xB - rm2; yE = yB + rm1;
      xF = xB + rn2; yF = yB - rn1;
    } else
    { xE = xB + rm2; yE = yB - rm1;
      xF = xB - rn2; yF = yB + rn1;
    }
    points[0] = IX(xB); points[1] = IY(yB);
    points[2] = IX(xF); points[3] = IY(yF);
    points[4] = IX(xD); points[5] = IY(yD);
    points[6] = IX(xE); points[7] = IY(yE);
    points[8] = points[0]; points[9] = points[1];
    fillpoly(5, points);
  }