  /* GRASPTC.H:    䠩, ।祭  祭  
		  , ᯮ騩 㭪樨   GRASPTC.

		  Header file, to be used in any module that uses
		  the functions defined in GRASPTC.
  */
  #ifndef __HUGE__
  #error Use Huge Memory Model
  #endif

  #include <stdio.h>
  #include <graphics.h>

  extern FILE *fplot;

  /* ᫨ ६ 'fplot'  㭪樨 fopen() 㤥 ਯ-
     ᠭ ஥ 祭,  ᫥騥 饭  㭪
     initgr(), move(), draw(), grtext(), arc_uc(), circle80_pc(),
     circle80_uc(), drawarc3()  fillet() 맮  
     몠 HP-GL  室 ⮪ 'fplot'.

     If we assign a value to 'fplot', using fopen(), subsequent
     calls to initgr(), move(), draw(), grtext(), arc_uc(),
     circle80_pc(), circle80_uc(), drawarc3(), and fillet() will
     cause HP-GL instructions to be written to the stream 'fplot'.
  */

  extern int X__max, Y__max, foregrcolor, backgrcolor, colorsum;

  /* ᫥ 맮 㭪樨 initgr()   ६  ᠭ
     ᨬ 祭 ᥫ न   X  Y, 
     梥 䮭  ᭮ ࠦ  㬬  . 孨
      㣮 ࠭  砫 ⥬ ᥫ न.

     After initgr() has been called, these variables indicate the
     maximum pixel coordinates X and Y, the foreground and background
     colors, and the sum of these two color codes. The upper-left
     corner of the screen is the origin of the pixel-coordinate system.
  */

  extern float x_max, y_max, horfact, vertfact;

  /* ᫥ 맮 㭪樨 initgr()  ६ x_max  y_max 
     ᠭ ᨬ 祭 짮⥫᪨ न (
     x_max = 10.0)  ᫥ 樥 horfact = X__max/x_max,
     vertfact = Y__max/y_max. 砫 짮⥫᪮ ⥬ -
      ᯮ    㣫 ࠭.

     After initgr() has been called, x_max and y_max denote the maximum
     user coordinates (with x_max = 10.0), and horfact = X__max/x_max,
     vertfact = Y__max/y_max.
     The lower-left corner of the screen is the origin of the user-
     coordinate system.
  */

  void initgr(void);

  /* 㭪 । ⨯ ᪮   ⢫
     ४祭  ᪨ ०, 騩 襥 ࠧ襭

     Detects the graphics adapter, and switches to the graphics mode
     that has the highest resolution.
  */

  void boundaries_uc(void);

  /* ᫨ 祭 x_max = 10.0 ਥ  ⭮ 樨,
      ⮩ ६    㣮 祭. 
       ᤥ ⮫쪮 ᫥ 饭  㭪樨 initgr().
      ᫥騩 맮 㭪樨 boundaries_uc ᯥ -
     室  ६ y_max, horfact  vertfact.

     If the value x_max = 10.0 should be unacceptable to you, you
     can assign a different value to x_max. You can do this only after
     calling initgr(); after such an assignment a call to boundaries_uc
     takes care that the variables y_max, horfact, and vertfact are
     updated accordingly.
  */

  int IX(float x);
  int IY(float y);

  /* ८ࠧ  짮⥫᪨  ᥫ न
     Conversion from user to pixel coordinates */

  void move(float x, float y);
  void draw(float x, float y);

  /*  㬥 x  y ।  ⥪   ⥬
      짮⥫᪨ न.  饭  㭪樨 draw()
      稢 १ אַ   ।饩 樨 
       ⥪ .

     The arguments x and y are the user coordinates of the new
     current position. In case of draw(), a straight line is drawn
     from the previous to the new current position.
  */

  void endgr(void);
  void to_text(void);
  /*   㭪樨 ᯥ稢   ⥪⮢ ०. 
     ⫨ ⥬,  㭪 to_tex() 믮 ४祭
     , ⮣   맮 㭪樨 endgr() 
     ⨥ - .

     These two function switch back to text mode. They differ in
     that to_text() does this  immediately,  while endgr() waits
     until a key is pressed.
  */

  void invertpixel(int X, int Y);

  /*   梥 ᢥ祭 ᥫ (X, Y), (  ᥫ-
       न)  梥 䮭  梥 ࠦ  .

     Changes pixel (X, Y) (given in pixel coordinates) from background
     to foreground color and vice versa.
  */

  void grtext(float xleft, float ylower, float heightpercent, char *str);

  /*  뢮  ࠭ ⥪⮢ ப  ᪮ ०.
     窠 (xleft, ylower),   ⥬ 짮⥫᪨ -
     , ।    㣫 ࢮ ᨬ.
      ᨬ ਬ୮ ࠢ `heightpercent' 業⮢  
     ࠭. ப ᯮ ਧ⠫쭮, ⨯  - ᠭ-.

     Writes the string 'str' while in graphics mode. Point (xleft, ylower),
     given in user coordinates, is the lower-left corner of the first
     character. The character height is approximately equal to
     'heightpercent' per cent of the screen height. The string is written
     horizontally, and the font is 'sans serif'.
  */

  void circle_uc(float x, float y, float r);

  /* 稢 㦭  業஬  窥 (x, y)   ࠤᮬ r,
     㬥    짮⥫᪨ न.

     Draws a circle, with center (x, y) and radius r given in
     user coordinates.
  */

  int XPIX(float xdim);
  int YPIX(float ydim);

  /*  㭪樨 ८ࠧ ﭨ,    짮-
     ⥫᪨ न,  ﭨ  ⥬ ᥫ न.

     These functions convert distances in user coordinates into distances
     in pixel coordinates.
  */

  #define PI 3.141592653589793

  void line_uc(float x1, float y1, float x2, float y2);

  /* 稢 १ אַ   窠 (x1, y1) 
     (x2, y2). 㬥   짮⥫᪨ न.

     Draws a line between (x1, y1) and (x2, y2). The arguments are
     user coordinates.
  */

  void arc_uc(float xC, float yC, float stangle,
	      float endangle, float radius, int nlinesegments);

  /* 稢 㣠 㦭  묨 祭ﬨ न
     業, 砫쭮  筮 㣫  ࠤ   -
     ⥫᪨ न. 㣠 பᨬ १ אַ
     , ⢮  । ᫥ 㬥⮬.

     Draws a circular arc, with a given center, start angle,
     end angle, and radius, given in user coordinates and radians.
     The arc is approximated by as many line segments as the final
     argument indicates.
  */

  struct arc_uctype
  { float x, y, xstart, ystart, xend, yend;
  };
  /* । ⨯  ᯮ짮 ⨯ `struct arc_uctyre'
      । ( ) ६;  ⠪ ६
       ᯮ짮  ⢥ 㬥 㭪樨 getarc_uc().

     Type definition which enables us to use type 'struct arc_uctype'
     to define (and declare) variables; the address of such a variable
     can be used as an argument of function getarc_uc().
  */

  void getarc_uc(struct arc_uctype *arccoords);

  /* ᫥ 맮 㭪権 arc_uc()  fillet() 㭪 getarc_uc()
      祭 짮⥫᪨ न  業, 砫쭮
      筮 祪 㣨  , 㪠 ᮬ `arccoords'

     After a call to arc_uc() or fillet(), function getarc_uc() places
     the (user) coordinates of the center, the start point, and the end
     point of the arc in the structure pointed to by 'arccoords'.
  */

  float angle(float x, float y);

  /* 頥 祭 㣫 (-PI/2 < angle <= 3*PI/2)  -
     ⥫쭮  x  אַ , 室饩 १  砫
     न O   (x, y).

     Returns the angle (-PI/2 < angle <= 3*PI/2) between the positive
     x-axis and the line through the origin O and point (x, y).
  */

  float drawarc3(float xA, float yA, float xB, float yB,
		 float xC, float yC, float *pr);

  /* 稢 㣠, ᮥ 窨 (xA, yA)  (xC, yC), 
     室 ⠪ १  (xB, yB).  㣨   -
       㪠⥫ `pr'. 㬥    짮-
     ⥫᪨ न. 㭪 頥 ⥫쭮 ᫮, ᫨
     窨 A, B, C,   ⮬ 浪, 室  ࠢ ⨢
      ᮢ ५,  ⥫쭮 ᫮, ᫨  ᯮ-
       ᮢ ५. ᫨ 窨 A, B, C 室   אַ
     ,  頥 ᫮ ࠢ   祣  稢.

     Draws an arc that connects the points (xA, yA) and (xC, yC), and
     that passes through point (xB, yB). The radius of the arc is
     placed in the variable pointed to by 'pr'. The arguments are in
     user coordinates. The function returns a positive value if the
     points A, B, C, in that order, are counter-clockwise, and a
     negative value if they are clockwise.If A, B, and C are on a
     straight line, the returned value is zero and nothing is drawn.
  */

  float fillet(float xA, float yA, float xB, float yB,
	       float xC, float yC, float r);

  /*  㣫, ࠧ묨 १   AB  BC, -
     稢 㣠 㦭  ࠤᮬ r, ⥫쭠  ⨬ १.
      㣠  ᯮ짮  㣫 㣫  窥 B.
     砫쭠  筠 窨 ⮩ 㣨   祭 ⥬
     饭  㭪樨 getarc_uc().  㬥 ࠦ 
      짮⥫᪨ न. 頥 祭 ⠪
     ,    㭪樨 drawarc3().

     Instead of the angle formed by the line segments AB and BC, an
     arc with radius r and tangent to these line segments is drawn.
     The arc can be used as a rounded corner B. The start and end
     points of the arc can be obtained by calling getarc_uc(). All
     arguments are in user coordinates. Returned value: see drawarc3().
  */

  void fillcircle_uc(float x, float y, float radius);

  /* 稢    業஬  ࠤᮬ, 묨
       짮⥫᪨ न. 饭  ⮩ 㭪樨
      ।⢮ 饭  㭪樨 ࡮  setfillstyle()
      ⠭ ⨯   蠡 .

     Draws a filled circle, with center and radius given in
     user coordinates. A call to this function should be preceded
     by a call to the Turbo C function setfillstyle() to set the
     fill style and fill pattern.
  */

  void circle80_pc(int XC, int YC, int R);

  /* 稢 㦭, பᨬ㥬 80 १  .
      ⨢ 㭪樨 circle() ࡮ , 㭪 circle80_pc()
     ᯥ稢 ஢ ᥫ ᫥ 饭  㭪樨
     setwritemode(XOR_PUT). ஬ ⮣  䠩 HP-GL 뢠 80
     १   , ᫨ ६ `fplot'  ࠢ NULL.
     㬥 ࠦ  ᥫ न.

     Draws a circle approximated by 80 line segments. In contrast to
     the Turbo C function circle(), circle80_pc() inverts pixels after
     the call setwritemode(XOR_PUT). Also, the 80 line segments are
     written in an HP-GL file if 'fplot' is not equal to NULL.
     The arguments are pixel coordinates.
  */

  void circle80_uc(float xC, float yC, float r);

  /* 筠 㭪樨 circle80(),  㬥 ࠦ  
     짮⥫᪨ न.

     Similar to circle80(), but with arguments in user coordinates.
  */

  void fatline0(float x1, float y1, float x2, float y2, float d);

  /* 稢 ⮫   ਭ d  묨 楢묨
     窠 (x1, y1)  (x2, y2). ᪨ 稢 
     אַ㣮쭨, । 窨  ⨢ ஭ ண
     ᮢ  묨 楢묨 窠. 㬥 ࠦ 
      짮⥫᪨ न. . ⠪ ᠭ 㭪権
     fatline()  sharpjoint().

     Draws a fat line with thickness d between the end points
     (x1, y1) and (x2, y2). In fact a filled rectangle is drawn
     with the given end points as midpoints of two opposite sides.
     The arguments are in user coordinates. See also fatline() and
     sharpjoint().
  */

  void fatline(float x1, float y1,  float x2, float y2, float d);

  /*  筠 㭪 fatline0( ),  ⥫쭮 稢
       㣠  楢묨 窠  ⢥ 業஢
       ࠤᮬ d/2.

     As fatline0(), but now two filled circles with the end points as
     centers and d/2 as their radius are also drawn.
  */

  void sharpjoint(float d);
  /* ᫥ 믮  饭:
     After the three calls:
        fatline0(xP, yP, xQ, yQ, d);
        fatline0(xQ, yQ, xR, yR, d);
        sharpjoint(d);
      窥 祭 Q 㤥 祭  㣮.
     there will be a sharp angle at Q, the point of intersection.
  */
