  /* HILBERT:          ਢ 졥  浪
		       Hilbert curves of any order.
  */
  #include "grasptc.h"

  typedef struct {float x, y;} vec;
  int recdepth, steps;

  void Hilbert(vec A, vec B, vec C, vec dAB, vec dAC, int n)
  { vec D, E, F, G, H, I, J, K, L;
    if (n > 0)
    { D.x = (A.x + C.x - dAC.x)/2;
      D.y = (A.y + C.y - dAC.y)/2;
      E.x = (A.x + B.x - dAB.x)/2;
      E.y = (A.y + B.y - dAB.y)/2;
      F.x = D.x + dAC.x; F.y = D.y + dAC.y;
      G.x = F.x + E.x - A.x; G.y = F.y + E.y - A.y;
      H.x = G.x + dAB.x; H.y = G.y + dAB.y;
      I.x = F.x + B.x - A.x; I.y = F.y + B.y - A.y;
      J.x = C.x + H.x - F.x; J.y = C.y + H.y - F.y;
      K.x = I.x - dAC.x; K.y = I.y - dAC.y;
      L.x = H.x - dAC.x; L.y = H.y - dAC.y;
      Hilbert(A, D, E, dAC, dAB, n-1);
      draw(F.x, F.y);         /* Link DF */
      Hilbert(F, G, C, dAB, dAC, n-1);
      draw(H.x, H.y);         /* Link GH */
      Hilbert(H, I, J, dAB, dAC, n-1);
      draw(K.x, K.y);         /* Link IK */
      dAB.x = -dAB.x; dAB.y = -dAB.y;
      dAC.x = -dAC.x; dAC.y = -dAC.y;
      /*  These changes in dAB and dAC apply
          only to local copies
      */
      Hilbert(K, B, L, dAC, dAB, n-1);
    }
  }

  void square(float xA, float yA, float xB, float yB, float xC, float yC)
  { vec A, B, C, dAB, dAC;
    A.x = xA; A.y = yA;
    B.x = xB; B.y = yB;
    C.x = xC; C.y = yC;
    dAB.x = (xB - xA)/steps;
    dAB.y = (yB - yA)/steps;
    dAC.x = (xC - xA)/steps;
    dAC.y = (yC - yA)/steps;
    move(xA, yA);
    Hilbert(A, B, C, dAB, dAC, recdepth);
  }

  main()
  { float xCenter, yCenter, h, xP, yP, xQ, yQ, xR, yR;
    printf /* "Enter the recursion depth: " */
	 ("\n 㡨 ४ᨨ :  ");
    scanf("%d", &recdepth);
    steps = (1 << recdepth) - 1;
    /* steps = power(2, recdepth) - 1
    */
    initgr();
    xCenter = x_max/2; 
    yCenter = y_max/2; 
    h = y_max/40;
    xP = xR = xCenter - 3 * h; 
    xQ = xCenter + 3 * h;
    yP = yQ = yCenter - 4 * h; 
    yR = yCenter + 4 * h;
    square(xQ, yQ, xR, yR, xQ+8*h, yQ+6*h); /* ࠢ  */
					    /* Right square
					    */
    square(xR, yR, xP, yP, xR-8*h, yR);     /*    */
					    /* Left square    */
    square(xP, yP, xQ, yQ, xP, yP-6*h);     /*   */
					    /* Lower square   */
    endgr();
  }
