  /* SDRAW: 祭   ਬ ""  
	    Line drawing, using a mouse and a menu.
  */

  #include <conio.h>
  #include <dos.h>
  #include <stdio.h>
  #include <alloc.h>
  #include <process.h>
  #include <string.h>
  #include <ctype.h>
  #include <stdlib.h>
  #include <math.h>
  #include "grasptc.h"

  #define LINTABLEN 8000
  #define STRTABLEN 1000
  #define MENUWIDTH 100
  #define BOXH 16
  #define ESC 27
  union REGS regs;

  void circ_arc(int *px, int *py);
  int Xpixel(int x), Ypixel(int y), xhpg(int X), yhpg(int Y);
  int msinit(int Xlo, int Xhi, int Ylo, int Yhi);
  void msget(int *pX, int *pY, int *pbuttons);
  int msread(int *pX, int *pY, int *pbuttons);

  void cursor(int X, int Y);
  void addline(int Xstart, int Ystart, int X, int Y);
  void addstring(int X, int Y, char *str);
  void wrlines(void);
  int confirmed(void);
  void rdlines(void);
  void initmenu(void);
  int getstring(int X, int Y, char *mes, char *str, int boxcode);
  void clearrectangle(int Xtop, int Ytop, int Xbottom, int Ybottom);
  char ermes(char *str);
  void displaybotlin(char *str);
  void defaultbotlin(void);
  void drline(int x1, int y1, int x2, int y2);
  void drawnewline(int x1, int y1, int x2, int y2);
  void endprogram(void);
  void newposition(int *px, int *py, int *pX, int *pY, int *pbut);
  void refresh(int x, int y);
  void textinput(int *px, int *py, int *pX, int *pY);
  void selectobject(int *pX, int *pY);
  void getline(int *pXstart, int *pYstart);
  void txtcursor(int X, int Y);
  void selectlinoptions
  (int i, int *pX, int *pY, int XX1, int YY1, int XX2, int YY2);
  void selecttxtoptions(int i, int *px, int *py);
  void secondmenu(void);
  void boxes(int n, int primary);
  void invertbox(int i, int x, int y, int primary);
  void os_shell(int x, int y);
  void arrowhead(int *px, int *py);
  int round(float x);

  struct lin_tab_elt {int x1, y1, x2, y2;} *table;
  struct str_tab_elt {int x1, y1; char *s;} *strtable;

  int ntable=0, ntxttable=0, Xmin, Ymin, Xmax, Ymax, xmin, ymin,
    xmax, ymax, charheight, charwidth, leftboundary, cursordraw;

  char *menuptr, *linbufptr, *boxbuf;
  long x_max200, y_max200;
  int y200, coordinates=0, modified=0;

  #define txt(linenr, str) gotoxy(1, linenr); cprintf(str);

  main()
    { int buttons, xm, ym, i, X, Y, x, y;
    clrscr();

/* " SDRAW: A program to draw lines, arcs, and text, and to produce
     HP-GL files; these files can be read by this very  program and
     by, for example, WordPerfect 5.0 and Ventura Publisher.
     You can draw straight lines as follows:
     Move the cursor  to one  end point  of  the line,  then  press
     a mouse button,  and move  the cursor  to the other end point.
     Finally, release the mouse button.
     Normally,  the cursor  can  be  placed  only  at  grid  points
     that  horizontally  and  vertically  lie  eight  units  apart.
     If you want  the cursor  to move  very  small  distances,  use
     the four arrow keys.  Press  the Home-key  to move  the cursor
     back to the nearest grid point.
     For other operations, use the mouse and  the menu  and  follow
     the directions displayed on the bottom line.
     Press any key on the keyboard..."
  */

    txt(1, "SDRAW: ணࠬ   稢  १  ,  ,");
    txt(2, "⥪⮢ ப  ନ஢ 䠩 ⨯ HP-GL;  䠩");
    txt(3, "⥬   ⠭ ⮩  ணࠬ  , ਬ,");
    txt(4, "⠬ WordPerfect 5.0  Ventura Publisher.            ");
    txt(6, "१    祭 ᫥騬 ࠧ:     ");
    txt(7, "   砫  १    ");
    txt(8, "   '',  ᮢ     筮  窮");
    txt(9, "१      ''.              ");
    txt(11, "ଠ쭮       ⮫쪮   窨  ⪨,");
    txt(12, "室騥  ﭨ 쬨    㣠. ᫨");
    txt(13, " 㦭 ६       ﭨ, ");
    txt(14, "ᯮ     ५.    ⨨  ");
    txt(15, " 'Home'    襩 窥  ⪨.");
    txt(17, " 㣨 権 㦭 ᯮ짮  ''  ᮢ⭮ ");
    txt(18, "  ᫥ 㪠, ⮡ࠦ    ப.");
    txt(20, "    ...");        getch();
    initgr();
    charwidth = textwidth("A"); charheight = textheight("A");
    x_max200 = 200 * x_max; y_max200 = y200 = 200 * y_max;
    Xmin = 4; Xmax = X__max - 4;
    Ymin = 2; Ymax = Y__max - 16;
    table = farmalloc((long) LINTABLEN * sizeof(struct lin_tab_elt));
    strtable = farmalloc((long) STRTABLEN * sizeof(struct str_tab_elt));
    menuptr = farmalloc((long)imagesize(0, 0, MENUWIDTH+1, Ymax-1));
    linbufptr = farmalloc((long)imagesize(MENUWIDTH, 0, X__max, 16));
    boxbuf = farmalloc((long)imagesize(0, 0, MENUWIDTH-2, BOXH));
    if (table == NULL || strtable == NULL || menuptr == NULL ||
	linbufptr == NULL || boxbuf == NULL)
		      /* "Memory  error" */
    { to_text(); cprintf("訡 "); exit(1);
    }
    xmax = xhpg(Xmax); ymax = yhpg(Ymin);
    xmin = xhpg(Xmin); ymin = yhpg(Ymax);
    leftboundary = xhpg(MENUWIDTH+14);


    if (msinit(0, (int)x_max200, 0, (int)y_max200) == 0)
			   /* "No mouse or mouse driver" */
    { to_text(); cprintf(" ''  ࠩ  ");
      exit(1);
    }
    while (msread(&xm, &ym, &buttons) >= 0) ;

    x = xm; y = ym;
    refresh(x, y);
    do
    { newposition(&x, &y, &X, &Y, &buttons);
      if (buttons && X < MENUWIDTH)
      { do newposition(&x, &y, &X, &Y, &buttons); while (buttons);
	     /* Now the mouse button is no longer pressed down! */
	     /*     '' 饭 !      */
	i = Y/BOXH;
			       /* Highlight selected item       */
	invertbox(i, x, y, 1); /* 뤥 ࠭  */
        switch (i)
        { case 0: rdlines(); break;
          case 1: wrlines(); break;
          case 2:  /* Clear */
            if (confirmed())
            { ntable = ntxttable = 0; modified = 0; refresh(x, y);
            } else invertbox(i, x, y, 1);
            break;
          case 3: if (confirmed()) endprogram(); break;
          case 4: os_shell(x, y); break;
          case 5:
            textinput(&x, &y, &X, &Y); break;
          case 6:
            selectobject(&x, &y); break;
          case 7:
            coordinates = 1 - coordinates;
            clearrectangle(512, Ymax+2, Xmax-1, Y__max-1);
            break;
          case 8:
            circ_arc(&x, &y); break;
          case 9:
            refresh(x, y); break;
          case 10: arrowhead(&x, &y);
        }
        if (i != 2 && i != 4 && i != 9) invertbox(i, x, y, 1);
      } else
      if (buttons) getline(&x, &y);
    } while (1);
  }

  /* Functions in alphabetic order:
     㭪樨  䠢⭮ 浪 :
  */

void addline(int xstart, int ystart, int x, int y)

  { int aux;
    if (xstart == x && ystart == y) return;
    if (ntable == LINTABLEN)
			 /* "Line table full." */
    { displaybotlin(" १ ."); return;
    }
    if (xstart > x || xstart == x && ystart > y)
    { aux = xstart; xstart = x; x = aux;
      aux = ystart; ystart = y; y = aux;
    }
    table[ntable].x1 = xstart; table[ntable].y1 = ystart;
    table[ntable].x2 = x; table[ntable++].y2 = y;
    modified = 1;
  }

void addstring(int x, int y, char *str)

  { char *p;
    if (ntxttable == STRTABLEN)
		       /* "String table full." */
    { displaybotlin(" ப ."); return;
    }
    strtable[ntxttable].x1 = x;
    strtable[ntxttable].y1 = y;
    p = farmalloc((long) (strlen(str)+2));
    if (p == NULL) {to_text();    /* "Memory problem" */
			  cprintf("஡  ");
		    exit(1);}
    strcpy(p, str);
    strtable[ntxttable++].s = p;
    modified = 1;
  }

void arrowhead(int *px, int *py)

  { int xhead, yhead, xtail, ytail, X, Y, buttons, xar[3], yar[3], i;
    float phi, len, xx[3], yy[3], c, s;
    char str[50];
    displaybotlin
    	       /* "Move cursor to arrow tail and press button." */
	  ("    砫 ५   .");
    do newposition(px, py, &X, &Y, &buttons); while (buttons == 0);
    xtail = *px; ytail = *py;
    displaybotlin
    	/* "Move cursor to end of arrow head and press button." */
	   ("     ५   .");
    do newposition(px, py, &X, &Y, &buttons); while (buttons == 0);
    xhead = *px; yhead = *py;
    phi = angle(xhead-xtail, yhead-ytail);
    c = cos(phi); s = sin(phi);
    if (getstring(MENUWIDTH+20, 100,
		   /*  "Length of arrow head (e.g. 40): " */
		   "  ५ (ਬ, 40): ",
		    str, 1) == 0) return;
    if (sscanf(str, "%f", &len) == 0 || len <= 0) return;
    xx[0] = yy[0] = 0.0; xx[1] = xx[2] = -len;
    yy[1] = 0.3 * len; yy[2] = -yy[1];
    xar[0] = xhead; yar[0] = yhead;
    for (i=1; i<3; i++)
    { xar[i] = xhead + round(c * xx[i] - s * yy[i]);
      yar[i] = yhead + round(s * xx[i] + c * yy[i]);
      drawnewline(xar[i-1], yar[i-1], xar[i], yar[i]);
    }
    drawnewline(xar[2], yar[2], xhead, yhead);
  }

void boxes(int n, int primary)

  { int i, left, right, offset, level, bottom;
    if (primary)
    { left = 0; offset = 0; bottom = Ymax;
    } else
    { left=7; offset=5; bottom = offset + n * BOXH;
    }
    right = left+MENUWIDTH-1;
    clearrectangle(left+1, offset+1, right-1, bottom-1);
    setwritemode(COPY_PUT);
    for (i=0; i<=n; i++)
    { level = offset+i*BOXH;
      line(left, level, right, level); /* Horizontal lines */
				   /* ਧ⠫  */
    }
    line(left, offset, left, bottom);  /* Vertical lines   */
				   /* ⨪    */
    line(right, offset, right, bottom);
    setwritemode(XOR_PUT);
  }

void circ_arc(int *px, int *py)

  { char str[100];
    float phi=0, delta, x1, y1, x2, y2, alpha, r, rx, ry;
    int i, n=1, X, Y, buttons, xC, yC, xA, yA;
    if (getstring(MENUWIDTH+20, 100,
    	  /* "Angle in degrees (negative if clockwise): " */
	 "  ࠤ (, ᫨  ᮢ ५): ",
	  str, 1) == 0)	 return;
    if (sscanf(str, "%f", &phi) == 0) return;
    phi *= PI/180;                /* phi now in radians         */
				  /* ⥯ 㣮 phi  ࠤ */
    if (getstring(MENUWIDTH+20, 100,
	  /* "How many approximating line segments (e.g. 20): " */
	    "쪮 பᨬ १? (ਬ, 20): ",
        str, 1) == 0)      return;
    if (sscanf(str, "%d", &n) == 0 || n <= 0) return;
    displaybotlin (          /* "Press mouse button at center." */
		    "    ''  樨 業.");
    do newposition(px, py, &X, &Y, &buttons); while (buttons == 0);
    xC = *px; yC = *py; cursor(xC, yC);    /* Keep center marked */
			     /* થ ⠥  樨 業 */
    cursordraw = 1 - cursordraw;
    displaybotlin         /* "Press mouse button at start point."*/
	  ("    ''  樨 砫쭮 窨.");
    do newposition(px, py, &X, &Y, &buttons); while (buttons == 0);
    defaultbotlin();
    cursor(xC, yC);                    /* Erase cursor at center */
				    /* ࠭   業 */
    cursordraw = 1 - cursordraw;
    xA = *px; yA = *py; delta = phi/n;
    x1 = xA; y1 = yA; rx = x1-xC; ry = y1-yC;
    alpha = angle(rx, ry);      /* 'angle' is defined in LINDRAW */
			 /* 㭪 'angle' ।  LINDRAW */
    r = sqrt(rx * rx + ry * ry);
    cursor(xA, yA);
		/* Erase cursor because of the COPY_PUT drawmode */
		/* 㦭 ࠭  - ० COPY_PUT  */
    setwritemode(COPY_PUT);
    for (i=0; i<n; i++)
    { alpha += delta;
      x2 = xC + r * cos(alpha); y2 = yC + r * sin(alpha);
      drawnewline(x1, y1, x2, y2);
      x1 = x2; y1 = y2;
    }
    setwritemode(XOR_PUT);
    cursor(xA, yA); /* Draw cursor */   /* 稢  */
  }

void clearrectangle(int Xtop, int Ytop, int Xbottom,int Ybottom)

  { struct viewporttype vp;
    getviewsettings(&vp);
    setviewport(Xtop, Ytop, Xbottom, Ybottom, 0);
    clearviewport();
    setviewport(vp.left, vp.top, vp.right, vp.bottom, vp.clip);
  }

int confirmed(void)

  { char ch;
    if (ntable + ntxttable > 0 && modified)
	      /* "Save drawing? */
    { ch = ermes("࠭ ⥦? (Y/N/Esc): ");
      ch = tolower(ch);
      if (ch == ESC) return 0;
      if (ch == 'y') wrlines();
    }
    return 1;
  }

void cursor(int x, int y)

  { int Xm4, Xp4, Ym2, Yp2, Ym1, Yp1, X, Y;
    static char str[50];
    X = Xpixel(x); Y = Ypixel(y);
    Xm4=X-4; Xp4=X+4; Ym2=Y-2; Yp2=Y+2; Ym1=Y-1; Yp1=Y+1;
    line(Xm4, Ym2, Xp4, Ym2); line(Xm4, Yp2, Xp4, Yp2);
    line(Xm4, Ym1, Xm4, Yp1); line(Xp4, Ym1, Xp4, Yp1);
    if (coordinates && cursordraw) /* See explanation below */
				   /* . ᭥     */
    { sprintf(str, "x=%4d y=%4d", x, y);
      clearrectangle(512, Ymax+2, Xmax-1, Y__max-1);
      outtextxy(512, Y__max-5, str);
    }
    cursordraw = 1 -cursordraw;
    /* 祭 ६ 'cursordraw'           */
    /* Values of 'cursordraw': 1, 0, 1, 0, 1, ... */
    /* See also refresh().                        */
    /* . ⠪ 㭪  refresh().              */
  }

void defaultbotlin(void)

  { displaybotlin("");
  }

void displaybotlin(char *str)

  { clearrectangle(1, Ymax+2, X__max-1, Y__max-1);
    outtextxy(2, Y__max-5, str);
  }

void drawnewline(int x1, int y1, int x2, int y2)

  { drline(x1, y1, x2, y2);
    addline(x1, y1, x2, y2);
  }

void drline(int x1, int y1, int x2, int y2)

  { int aux, X1, Y1, X2, Y2;
    X1 = Xpixel(x1); Y1 = Ypixel(y1);
    X2 = Xpixel(x2); Y2 = Ypixel(y2);
    if (X1 == X2 && Y1 == Y2) return;
    if (X1 > X2 || X1 == X2 && Y1 > Y2)
    { aux = X1; X1 = X2; X2 = aux;
      aux = Y1; Y1 = Y2; Y2 = aux;
    }
    if (X1 < MENUWIDTH+8) X1 = MENUWIDTH+8;
    line(X1, Y1, X2, Y2);
  }

void endprogram(void)

  { to_text(); exit(0);
  }

char ermes(char *str)

  { int left=MENUWIDTH+20;
    char ch;
    getimage(left, 100, Xmax, 116, linbufptr);
    clearrectangle(left, 100, Xmax, 114);
    outtextxy(left+8, 112, str);
    ch = getch();
    putimage(left, 100, linbufptr, COPY_PUT);
    return ch;
  }

void getline(int *pxstart, int *pystart)

  { int x, y, xstart, ystart, buttons, x0, y0, X, Y;
    x = xstart = *pxstart; X = Xpixel(x);
    y = ystart = *pystart; Y = Ypixel(y);
    do
    { x0 = x; y0 = y;
      newposition(&x, &y, &X, &Y, &buttons);
      if (x != x0 || y != y0)
      { drline(xstart, ystart, x0, y0);  /* Erase */ /* ࠭ */
        if (x < leftboundary) {*pxstart=x; *pystart=y; return;}
	drline(xstart, ystart, x, y);     /* Drag  */ /* ७ */
      }
    } while (buttons);
    addline(xstart, ystart, x, y);
    *pxstart=x; *pystart=y;
  }

int getstring(int X, int Y, char *mes, char *str, int boxcode)

  { int len=strlen(mes), i=0, j, maxlen, k;
    char ch, s2[2];
    maxlen=X__max-10-X; s2[1] = '\0';
    if (boxcode)
    { getimage(X, Y-14, X__max-10, Y+2, linbufptr);
      clearrectangle(X, Y-14, X__max-10, Y+2);
      rectangle(X, Y-14, X__max-10, Y+2);
      outtextxy(X+4, Y, mes);
    }
    while(1)
    { j = (len+i)*charwidth;
      if (j >= maxlen) break;
      txtcursor(X+j, Y-6);                  /* Draw text cursor */
			     /* 稢 ⥪⮢  */
      ch = getch();
      txtcursor(X+j, Y-6);                 /* Erase text cursor */
				 /* ࠭ ⥪⮢  */
      if (ch == ESC) {i=0; break;}
      if (ch == '\n' || ch == '\r') break;
      if (ch == 8)         /* backspace */ /* ࠭ ᨬ */
      { if (--i < 0) i = 0;
        k = (len+i)*charwidth;
        clearrectangle(X+k, Y-charheight, X+k+charwidth, Y);
      } else
      { str[i] = s2[0] = ch;
        outtextxy(X+j, Y, s2);
        i++;
      }
    }
    str[i] = '\0';
    if (boxcode) putimage(X, Y-14, linbufptr, COPY_PUT);
    return *str;
  }

void initmenu(void)

  { int Y=BOXH/2+4;
    boxes(11, 1);
    outtextxy(4, Y,       "⥭"     ); /* "Read"       */
    outtextxy(4, Y+=BOXH, ""     ); /* "Write"      */
    outtextxy(4, Y+=BOXH, "࠭"   ); /* "Clear"      */
    outtextxy(4, Y+=BOXH, "室"      ); /* "Quit"       */
    outtextxy(4, Y+=BOXH, "室  "); /* "OS shell"   */
    outtextxy(4, Y+=BOXH, ""      ); /* "Text"       */
    outtextxy(4, Y+=BOXH, "롮"      ); /* "Select"     */
    outtextxy(4, Y+=BOXH, "न" ); /* "Coordinates"*/
    outtextxy(4, Y+=BOXH, "㣠"       ); /* "Arc"        */
    outtextxy(4, Y+=BOXH, ""); /* "Refresh"    */
    outtextxy(4, Y+=BOXH, "५"    ); /* "Arrow head" */
  }

void invertbox(int i, int x, int y, int primary)

  { int left, right, offset, level;
			     /* See also function 'boxes' */
			     /* . ⠪ 㭪 'boxes' */
    if (primary) {left=0; offset=0;} else {left=7; offset=5;}
    right = left+MENUWIDTH-1;
    level = offset + i * BOXH;
    cursor(x, y); /* Erase */
    getimage(left+1, level+1,  right-1, level+BOXH-1, boxbuf);
    putimage(left+1, level+1, boxbuf, NOT_PUT);
    cursor(x, y);        /* Restore */    /* ⠭ */
  }

int msinit(int Xlo, int Xhi, int Ylo, int Yhi)

  { int retcode;
    regs.x.ax = 0;
    int86(51, &regs, &regs);
    retcode = regs.x.ax; /* -1: installed;  0: not installed */
			 /* -1: ⠭; 0:  ⠭ */
    if (retcode == 0) return 0;
    regs.x.ax = 7; regs.x.cx = Xlo; regs.x.dx = Xhi;
    int86(51, &regs, &regs);
    regs.x.ax = 8; regs.x.cx = Ylo; regs.x.dx = Yhi;
    int86(51, &regs, &regs);
    return retcode;
  }

int msread(int *px, int *py, int *pbuttons)

  { static int x0=-10000, y0, but0;
    int xnew, ynew;
    do
    { if (kbhit()) return getch(); /* Key input */
			   /*    */
      regs.x.ax = 3;
      int86(51, &regs, &regs);
      xnew = regs.x.cx; ynew = regs.x.dx;
      *pbuttons = regs.x.bx;
    } while (xnew == x0 && ynew == y0 && *pbuttons == but0);
    *px = xnew; *py = y200 - ynew;
    x0 = xnew; y0 = ynew; but0 = *pbuttons;
    return -1;                        /* -1: No key input */
		       /* -1 :  뫮    */
  }

void newposition(int *px, int *py, int *pX, int *pY, int *pbut)

  { int ch, x0=*px, y0=*py, x, y;
    static int xm, ym, xcorr=0, ycorr=0;
    ch = msread(&xm, &ym, pbut); ch = tolower(ch);
    if (ch >= 0)
    { if (ch == 0)    /* Arrow keys are read as two characters, */
      { ch = getch(); /* the first of which is '\0'.            */
		      /*    ५ 뢠   */
		      /*   ᨬ,    '\0'    */
        switch (ch)
	{ case 72: ycorr++; break;   /* Up     */ /*   */
	  case 75: xcorr--; break;   /* Left   */ /*   */
	  case 77: xcorr++; break;   /* Right  */ /* ࠢ */
	  case 80: ycorr--; break;   /* Down   */ /*    */
	  case 71: xcorr = ycorr = 0; break;      /* Home   */
        }
      }
    }
    x = xm + xcorr; y = ym + ycorr;
    if (x < xmin) x = xmin;
    if (x > xmax) x = xmax;
    if (y < ymin) y = ymin;
    if (y > ymax) y = ymax;
    if (x != x0 || y != y0)
    { cursor(x0, y0);    /* Erase   */  /* ࠭    */
      cursor(x, y);      /* Display */  /* ⮡ࠦ */
    }
    *px = x; *py = y;
    *pX = Xpixel(x); *pY = Ypixel(y);
  }

void os_shell(int x, int y)

  { to_text(); printf       /* "Type EXIT to return to SDRAW." */
		   ("  EXIT    SDRAW");
    system("");                              /* Go to OS shell */
				      /* ६ 室   */
    initgr(); refresh(x, y);
  }

void rdlines(void)

  { FILE *fp;
    int x1, y1, x2, y2, i, freshstart;
    char str[100];
    signed char ch;
				/*  "File name: " */
    if (getstring(MENUWIDTH+4, 18, " 䠩: ", str, 1) == 0)
						    return;
    fp = fopen(str, "r");
    if (fp == NULL)
    { while (ermes(  /* "Can't open file; press Esc."         */
		 "   䠩;  Esc.") != ESC) ;
      return;
    }
    freshstart = (ntable + ntxttable == 0);
    do ch = getc(fp); while (ch != '\n' && ch != EOF);
    setwritemode(COPY_PUT);
    while (fscanf(fp, "LT;PU;PA%d,%d;PD;PA%d,%d;",
                      &x1, &y1, &x2, &y2) == 4)
    { drawnewline(x1, y1, x2, y2);
      while (getc(fp) != '\n') ;    /* Skip rest of input line */
	  /* ⠫쭠   ப  ਭ */
    }
    setwritemode(XOR_PUT);
    while (fscanf(fp, "PU;PA%d,%d;LB", &x1, &y1) == 2)
    { i = 0;
      while (ch = getc(fp), ch != '\003' && ch != EOF) str[i++] = ch;
      str[i] = '\0';
      do ch = getc(fp); while (ch != '\n');
      addstring(x1, y1, str);
      outtextxy(Xpixel(x1), Ypixel(y1), str);
    }
    fclose(fp);
    if (freshstart) modified = 0;
  }

void refresh(int x, int y)

  { int i;
    static first=1;
      settextjustify(LEFT_TEXT, BOTTOM_TEXT); /* HP-GL convention */
					   /* 襭  HP-GL */
    if (first) first=0;          /* Saves time             */
	else clearviewport();    /*  ᮪饭 ६ */
    rectangle(0, 0, X__max, Y__max);
    line(0, Ymax, X__max, Ymax);
    defaultbotlin();
    initmenu();
    setwritemode(COPY_PUT);
    for (i=0; i<ntable; i++)
      drline(table[i].x1, table[i].y1, table[i].x2, table[i].y2);
    for (i=0; i<ntxttable; i++)
      outtextxy(Xpixel(strtable[i].x1), Ypixel(strtable[i].y1),
		strtable[i].s);
    setwritemode(XOR_PUT);
    cursordraw = 1;
    cursor(x, y);
	    /* If cursordraw = 1, cursor() draws a new cursor; */
	    /* if cursordraw = 0, cursor() erases the old one. */
	    /*  cursordraw = 1, 稢  ; */
	    /*  cursordraw = 0,   ࠥ.    */
  }

int round(float x)

  { return (int)(x < 0 ? x - 0.5 : x + 0.5);
  }

void secondmenu(void)

  { int Y=BOXH/2+9;
    getimage(0, 0, MENUWIDTH+8, Ymax-1, menuptr);
    boxes(4, 0);
    outtextxy(12, Y,       "");    /* "Delete" */
    outtextxy(12, Y+=BOXH, "७" );    /* "Move"   */
    outtextxy(12, Y+=BOXH, "  " );    /* "Copy"   */
    outtextxy(12, Y+=BOXH, "室  " );    /* "Escape" */
    displaybotlin               /* "Select operation." */
		("  㦭 .");
  }

void selectlinoptions

  (int i, int *px, int *py, int xx1, int yy1, int xx2, int yy2)
  { int j, l, x=*px, y=*py, x0, y0, dragmode, xxm, yym, buttons,
        *pivotx, *pivoty, dx, dy, first=1, X, Y, XXm, YYm,
	XX1=Xpixel(xx1), YY1=Ypixel(yy1),
	XX2=Xpixel(xx2), YY2=Ypixel(yy2);
    cursor(xx1, yy1); cursor(xx2, yy2);
			/* Display cursors at end points         */
			/* ⮡ࠦ   楢 窠 */
    xxm = (xx1+xx2)/2; yym = (yy1 + yy2)/2;
    XXm = Xpixel(xxm); YYm = Ypixel(yym);
    cursor(xxm, yym);           /* Display cursor at midpoint    */
				/* 뢮   । 窥 */
    cursor(x, y);               /* Erase                         */
				/* ࠭               */
    secondmenu();               /* Display secondary menu        */
				/* ⮡ࠦ 筮    */
    cursor(x, y);               /* Restore                       */
				/* ⠭         */
    do
    { newposition(&x, &y, &X, &Y, &buttons);
    } while (buttons == 0 || X >= MENUWIDTH || Y >= 5+4*BOXH);
    j = (Y-5)/BOXH;
    invertbox(j, x, y, 0);
    switch(j)
    { case 0:                   /* Delete */         /*  */
      { ntable--;
        for (l=i; l<ntable; l++) table[l] = table[l+1];
	drline(xx1, yy1, xx2, yy2);   /* Erase */    /* ࠭ */
        break;
      }
      case 1: case 2:        /* Move or Copy, respectively       */
			     /* ७   ᮮ⢥⢥ */
      { displaybotlin(  /*
     "Move to the midpoint or to an end point and press button." */
     "  ।  筮 窮   ");
        dragmode = -1;
        do
        { newposition(&x, &y, &X, &Y, &buttons);
          if (abs(X-XX1) < 3 && abs(Y-YY1) < 3) dragmode = 1; else
          if (abs(X-XX2) < 3 && abs(Y-YY2) < 3) dragmode = 2; else
          if (abs(X-XXm) < 9 && abs(Y-YYm) < 9) dragmode = 0;
        } while (buttons == 0 || dragmode < 0);
        while (newposition(&x, &y, &X, &Y, &buttons), buttons) ;
        /* Now buttons == 0 */
        x0 = x; y0 = y;
	displaybotlin(  /*
	"Drag by moving the cursor; then press button." */
	" ७ ६饭 , ⥬  ");
        while (newposition(&x, &y, &X, &Y, &buttons), buttons==0)
        { if (dragmode == 0) {pivotx = &xxm; pivoty = &yym;} else
          if (dragmode == 1) {pivotx = &xx1; pivoty = &yy1;} else
                             {pivotx = &xx2; pivoty = &yy2;}
          if (x != *pivotx || y != *pivoty)
	  { if (j == 1 || !first) drline(xx1, yy1, xx2, yy2);
				    /*  Erase */  /* ࠭   */
	    else                    /*  1 = Move,    2 = Copy   */
				    /*  1 = ७, 2 =   */
	    addline(xx1, yy1, xx2, yy2);
				    /* j = 2: Copy, first time  */
				    /* j = 2: ,  ࠧ */
            first = 0;
            cursor(xx1, yy1); cursor(xx2, yy2); cursor(xxm, yym);
            dx = x - x0; dy = y - y0;
            if (dragmode != 2) {xx1 += dx; yy1 += dy;} /* 0 or 1 */
            if (dragmode != 1) {xx2 += dx; yy2 += dy;} /* 0 or 1 */
            xxm = (xx1+xx2)/2; yym = (yy1 + yy2)/2;
            x0 = x; y0 = y;
            drline(xx1, yy1, xx2, yy2);
            cursor(xx1, yy1); cursor(xx2, yy2); cursor(xxm, yym);
            table[i].x1 = xx1; table[i].y1 = yy1;
            table[i].x2 = xx2; table[i].y2 = yy2;
          }
        }
      }
      invertbox(j, x, y, 0);
    }
    cursor(xx1, yy1); cursor(xx2, yy2); cursor(xxm, yym);
	      /* Erase cursors at end points and at midpoint   */
	      /* ࠭ ஢  ।  楢 窠 */
    *px=x; *py=y; defaultbotlin();
    modified = 1;
  }

void selectobject(int *px, int *py)

  { int x=*px, y=*py, buttons, i, xx1, yy1, xx2, yy2,
	dx, dy, X, Y, found=0;
    long deviation;
    displaybotlin(  /*
    " Move cursor to selected object and press button." */
    "    롨ࠥ ꥪ⮬   .");
    do newposition(&x, &y, &X, &Y, &buttons); while (buttons == 0);
    defaultbotlin();
    for (i=0; i<ntable && !found; i++)
    { xx1 = table[i].x1; yy1 = table[i].y1;
      xx2 = table[i].x2; yy2 = table[i].y2;
      if (x < xx1-4 || x > xx2+4  /* xx1 <= xx2 */
      || y < yy1-4 && y < yy2 || y > yy1+4 && y > yy2+4) continue;
      dx = xx2 - xx1; dy = yy2 - yy1;
      deviation = (long)(x-xx1)*dy-(long)(y-yy1)*dx;
      if (labs(deviation) < 10*(dx + abs(dy)))
      { selectlinoptions(i, &x, &y, xx1, yy1, xx2, yy2);
        found = 1;
      }
    }
    if (!found)
    { for (i=0; i<ntxttable && !found; i++)
      { xx1 = strtable[i].x1; yy1 = strtable[i].y1;
        if (abs(x-xx1)+abs(y-yy1) < 50)
        { selecttxtoptions(i, &x, &y);
          defaultbotlin();
          found = 1;
        }
      }
    }
    if (!found)
    { displaybotlin(   /* "Not found. Press Esc."  */
		      " ꥪ  .  Esc.");
      while (getch() != ESC) ;
      defaultbotlin();
    }
    *px=x; *py=y;
    cursor(x, y);  /* Erase */        /* ࠭  */
    putimage(0, 0, menuptr, COPY_PUT);
    cursor(x, y);  /* Restore */ /* ⠭  */
  }

void selecttxtoptions(int i, int *px, int *py)

  { int x=*px, y=*py, j, l;
    char *p=strtable[i].s;
    int xx=strtable[i].x1, yy=strtable[i].y1, X, Y, buttons;
    cursor(x, y);   /* Erase          */ /* ࠭  */
    cursor(xx, yy); /* Mark string    */ /* ⪠ ப     */
    secondmenu();   /* Secondary menu */ /* 筮    */
    cursor(xx, yy); /* Unmark string  */ /* ⨥ ⪨     */
    cursor(x, y);   /* Restore        */ /* ⠭   */
    do
    { newposition(&x, &y, &X, &Y, &buttons);
    } while (buttons == 0 || X>MENUWIDTH+8 || Y>=4*BOXH);
    defaultbotlin();
    j = Y/BOXH; invertbox(j, x, y, 0);
    switch(j)
    { case 0:           /* Delete */  /*  */
        ntxttable--;
        for (l=i; l<ntxttable; l++) strtable[l] = strtable[l+1];
        refresh(x, y); break;
      case 1: case 2:    /* Move or Copy, respectively       */
			 /* ७   ᮮ⢥⢥ */
	displaybotlin(   /*
	 "Move cursor to target location; then press button. */
	 " ७   㦭    ");
        while (newposition(&x, &y, &X, &Y, &buttons), buttons==0);
	/* Now button is pressed: arrived at target location */
	/*      窥 祭 */
        while (newposition(&x, &y, &X, &Y, &buttons), buttons);
		   /* Button released */  /*  饭 */
        if (j == 1) /* Move */
        { strtable[i].x1 = x; strtable[i].y1 = y;
        } else addstring(x, y, p);
        refresh(x, y);
     }
     *px = x; *py = y;
     modified = 1;
   }

void textinput(int *px, int *py, int *pX, int *pY)

  { int x=*px, y=*py, buttons, X, Y, nonempty;
    char str[100];
    displaybotlin(   /*
    "Move cursor to where text is to begin and press button. */
    "     砫 ⥪   ");
    do newposition(&x, &y, &X, &Y, &buttons); while (buttons == 0);
    clearrectangle(1, Ymax+2, X__max-1, Y__max-1);
    displaybotlin(  /*
    "Enter text; then press the Enter-key." */
    "  ⥪, 稢 ⨥   'Enter'");
    cursor(x, y);          /* Erase */  /* ࠭  */
    nonempty = getstring(Xpixel(x), Ypixel(y), "", str, 0);
    cursor(x, y);   /* Restore */ /* ⠭  */
    if (nonempty) addstring(x, y, str);
    defaultbotlin();
    *px=x; *py=y;
    *pX=X; *pY=Y;
  }

void txtcursor(int X, int Y)

  { line(X, Y-2, X, Y+2);
    line(X-2, Y-4, X-1, Y-3); line(X+2, Y-4, X+1, Y-3);
    line(X-2, Y+4, X-1, Y+3); line(X+2, Y+4, X+1, Y+3);
  }

void wrlines(void)

  { FILE *fp;
    char ch;
    int i, len;
    char str[100];
			/* "File name: " */
    if (getstring(104, 30, " 䠩: ", str, 1) == 0) return;
    fp = fopen(str, "r");
    if (fp != NULL)
    { fclose(fp);
      do
      { ch = ermes(  /* "Overwrite existing file? (Y/N): " */
		     "  騩 䠩? (Y/N): ");
        ch = tolower(ch);
      } while (ch != 'y' && ch != 'n');
      if (ch == 'n') return;
    }
    fp = fopen(str, "w");
    if (fp == NULL)
    { while (ermes(      /* "Can't open file; press Esc." */
	     "   䠩;  Esc.") != ESC) ;
      return;
    }
    fprintf(fp, "IN;SC%d,%d,%d,%d;SR1.2,3.0;\n",
                leftboundary, xmax, ymin, ymax);
    /* HP-GL: Initialize; extreme values of coordinates.
       ନ஢ 䠫 HP-GL:
       樠; । । 祭 न.
    */
    for (i=0; i<ntable; i++)
	 fprintf(fp, "LT;PU;PA%d,%d;PD;PA%d,%d;\n",
	   table[i].x1, table[i].y1, table[i].x2, table[i].y2);
    for (i=0; i<ntxttable; i++)
    { len = strlen(strtable[i].s);
      strtable[i].s[len] = '\003'; strtable[i].s[len+1] = '\0';
      fprintf(fp, "PU;PA%d,%d;LB%s;\n",
        strtable[i].x1, strtable[i].y1, strtable[i].s);
      strtable[i].s[len] = '\0';
    }
    fclose(fp); modified = 0;
  }

int xhpg(int X)

  { return (int)(X * x_max200 / X__max);
  }

  int Xpixel(int x)
  { return (int)((long)X__max * x / x_max200);
  }

int yhpg(int Y)

  { return (int)((Y__max - Y) * y_max200 / Y__max);
  }

int Ypixel(int y)

  { return Y__max - (int)((long)Y__max * y / y_max200);
  }
